#ifndef LZ8E_LANAI_Z8E_DEF_H
#define LZ8E_LANAI_Z8E_DEF_H


/*****************************
 ** Memory-mapped registers **
 *****************************/

/* Port 0 receive special registers, 0-5 */
#define	LZ8E_P0_RECV_REG_OFFSET	0
#define	LZ8E_P0_RECV_REG(A)		(((LZ8E_P0_RECV_REG_OFFSET+A)<<3))
#define	LZ8E_P0_RECV_REG_MSH(A)	(((LZ8E_P0_RECV_REG_OFFSET+A)<<3)+0)
#define	LZ8E_P0_RECV_REG_LSH(A)	(((LZ8E_P0_RECV_REG_OFFSET+A)<<3)+2)
#define	LZ8E_P0_RECV_REG_MSB(A)	(((LZ8E_P0_RECV_REG_OFFSET+A)<<3)+0)
#define	LZ8E_P0_RECV_REG_msb(A)	(((LZ8E_P0_RECV_REG_OFFSET+A)<<3)+1)
#define	LZ8E_P0_RECV_REG_lsb(A)	(((LZ8E_P0_RECV_REG_OFFSET+A)<<3)+2)
#define	LZ8E_P0_RECV_REG_LSB(A)	(((LZ8E_P0_RECV_REG_OFFSET+A)<<3)+3)

/* Port 0 send special registers, 0-1 */
#define	LZ8E_P0_SEND_REG_OFFSET	6
#define	LZ8E_P0_SEND_REG(A)		(((LZ8E_P0_SEND_REG_OFFSET+A)<<3))
#define	LZ8E_P0_SEND_REG_MSH(A)	(((LZ8E_P0_SEND_REG_OFFSET+A)<<3)+0)
#define	LZ8E_P0_SEND_REG_LSH(A)	(((LZ8E_P0_SEND_REG_OFFSET+A)<<3)+2)
#define	LZ8E_P0_SEND_REG_MSB(A)	(((LZ8E_P0_SEND_REG_OFFSET+A)<<3)+0)
#define	LZ8E_P0_SEND_REG_msb(A)	(((LZ8E_P0_SEND_REG_OFFSET+A)<<3)+1)
#define	LZ8E_P0_SEND_REG_lsb(A)	(((LZ8E_P0_SEND_REG_OFFSET+A)<<3)+2)
#define	LZ8E_P0_SEND_REG_LSB(A)	(((LZ8E_P0_SEND_REG_OFFSET+A)<<3)+3)

/* Port 1 receive special registers, 0-2 */
#define	LZ8E_PCIE_RECV_REG_OFFSET	8
#define	LZ8E_PCIE_RECV_REG(A)	(((LZ8E_PCIE_RECV_REG_OFFSET+A)<<3))
#define	LZ8E_PCIE_RECV_REG_MSH(A)	(((LZ8E_PCIE_RECV_REG_OFFSET+A)<<3)+0)
#define	LZ8E_PCIE_RECV_REG_LSH(A)	(((LZ8E_PCIE_RECV_REG_OFFSET+A)<<3)+2)
#define	LZ8E_PCIE_RECV_REG_MSB(A)	(((LZ8E_PCIE_RECV_REG_OFFSET+A)<<3)+0)
#define	LZ8E_PCIE_RECV_REG_msb(A)	(((LZ8E_PCIE_RECV_REG_OFFSET+A)<<3)+1)
#define	LZ8E_PCIE_RECV_REG_lsb(A)	(((LZ8E_PCIE_RECV_REG_OFFSET+A)<<3)+2)
#define	LZ8E_PCIE_RECV_REG_LSB(A)	(((LZ8E_PCIE_RECV_REG_OFFSET+A)<<3)+3)

/* Port 1 send special registers, 0-1 */
#define	LZ8E_PCIE_SEND_REG_OFFSET	11
#define	LZ8E_PCIE_SEND_REG(A)	(((LZ8E_PCIE_SEND_REG_OFFSET+A)<<3))
#define	LZ8E_PCIE_SEND_REG_MSH(A)	(((LZ8E_PCIE_SEND_REG_OFFSET+A)<<3)+0)
#define	LZ8E_PCIE_SEND_REG_LSH(A)	(((LZ8E_PCIE_SEND_REG_OFFSET+A)<<3)+2)
#define	LZ8E_PCIE_SEND_REG_MSB(A)	(((LZ8E_PCIE_SEND_REG_OFFSET+A)<<3)+0)
#define	LZ8E_PCIE_SEND_REG_msb(A)	(((LZ8E_PCIE_SEND_REG_OFFSET+A)<<3)+1)
#define	LZ8E_PCIE_SEND_REG_lsb(A)	(((LZ8E_PCIE_SEND_REG_OFFSET+A)<<3)+2)
#define	LZ8E_PCIE_SEND_REG_LSB(A)	(((LZ8E_PCIE_SEND_REG_OFFSET+A)<<3)+3)

/* Copy-Engine special registers, 0-3 */
#define	LZ8E_COPY_REG_OFFSET		13
#define	LZ8E_COPY_REG(A)		(((LZ8E_COPY_REG_OFFSET+A)<<3))
#define	LZ8E_COPY_REG_MSH(A)		(((LZ8E_COPY_REG_OFFSET+A)<<3)+0)
#define	LZ8E_COPY_REG_LSH(A)		(((LZ8E_COPY_REG_OFFSET+A)<<3)+2)
#define	LZ8E_COPY_REG_MSB(A)		(((LZ8E_COPY_REG_OFFSET+A)<<3)+0)
#define	LZ8E_COPY_REG_msb(A)		(((LZ8E_COPY_REG_OFFSET+A)<<3)+1)
#define	LZ8E_COPY_REG_lsb(A)		(((LZ8E_COPY_REG_OFFSET+A)<<3)+2)
#define	LZ8E_COPY_REG_LSB(A)		(((LZ8E_COPY_REG_OFFSET+A)<<3)+3)

/* LZ8E_CRC32-Engine special registers, 0-3 */
#define	LZ8E_CRC32_REG_OFFSET	17
#define	LZ8E_CRC32_REG(A)		(((LZ8E_CRC32_REG_OFFSET+A)<<3))
#define	LZ8E_CRC32_REG_MSH(A)	(((LZ8E_CRC32_REG_OFFSET+A)<<3)+0)
#define	LZ8E_CRC32_REG_LSH(A)	(((LZ8E_CRC32_REG_OFFSET+A)<<3)+2)
#define	LZ8E_CRC32_REG_MSB(A)	(((LZ8E_CRC32_REG_OFFSET+A)<<3)+0)
#define	LZ8E_CRC32_REG_msb(A)	(((LZ8E_CRC32_REG_OFFSET+A)<<3)+1)
#define	LZ8E_CRC32_REG_lsb(A)	(((LZ8E_CRC32_REG_OFFSET+A)<<3)+2)
#define	LZ8E_CRC32_REG_LSB(A)	(((LZ8E_CRC32_REG_OFFSET+A)<<3)+3)

/* Dispatch special registers, 0-5 */
#define	LZ8E_DISPATCH_REG_OFFSET	21
#define	LZ8E_DISPATCH_REG(A)		(((LZ8E_DISPATCH_REG_OFFSET+A)<<3))
#define	LZ8E_DISPATCH_REG_MSH(A)	(((LZ8E_DISPATCH_REG_OFFSET+A)<<3)+0)
#define	LZ8E_DISPATCH_REG_LSH(A)	(((LZ8E_DISPATCH_REG_OFFSET+A)<<3)+2)
#define	LZ8E_DISPATCH_REG_MSB(A)	(((LZ8E_DISPATCH_REG_OFFSET+A)<<3)+0)
#define	LZ8E_DISPATCH_REG_msb(A)	(((LZ8E_DISPATCH_REG_OFFSET+A)<<3)+1)
#define	LZ8E_DISPATCH_REG_lsb(A)	(((LZ8E_DISPATCH_REG_OFFSET+A)<<3)+2)
#define	LZ8E_DISPATCH_REG_LSB(A)	(((LZ8E_DISPATCH_REG_OFFSET+A)<<3)+3)

/* JTAG special registers, 0 */
#define	LZ8E_JTAG_REG_OFFSET		27
#define	LZ8E_JTAG_REG(A)		(((LZ8E_JTAG_REG_OFFSET+A)<<3))
#define	LZ8E_JTAG_REG_MSH(A)		(((LZ8E_JTAG_REG_OFFSET+A)<<3)+0)
#define	LZ8E_JTAG_REG_LSH(A)		(((LZ8E_JTAG_REG_OFFSET+A)<<3)+2)
#define	LZ8E_JTAG_REG_MSB(A)		(((LZ8E_JTAG_REG_OFFSET+A)<<3)+0)
#define	LZ8E_JTAG_REG_msb(A)		(((LZ8E_JTAG_REG_OFFSET+A)<<3)+1)
#define	LZ8E_JTAG_REG_lsb(A)		(((LZ8E_JTAG_REG_OFFSET+A)<<3)+2)
#define	LZ8E_JTAG_REG_LSB(A)		(((LZ8E_JTAG_REG_OFFSET+A)<<3)+3)

/* PCIE special registers, 0-24 */
#define	LZ8E_PCIE_REG_OFFSET		28
#define	LZ8E_PCIE_REG(A)		(((LZ8E_PCIE_REG_OFFSET+A)<<3))
#define	LZ8E_PCIE_REG_MSH(A)		(((LZ8E_PCIE_REG_OFFSET+A)<<3)+0)
#define	LZ8E_PCIE_REG_LSH(A)		(((LZ8E_PCIE_REG_OFFSET+A)<<3)+2)
#define	LZ8E_PCIE_REG_MSB(A)		(((LZ8E_PCIE_REG_OFFSET+A)<<3)+0)
#define	LZ8E_PCIE_REG_msb(A)		(((LZ8E_PCIE_REG_OFFSET+A)<<3)+1)
#define	LZ8E_PCIE_REG_lsb(A)		(((LZ8E_PCIE_REG_OFFSET+A)<<3)+2)
#define	LZ8E_PCIE_REG_LSB(A)		(((LZ8E_PCIE_REG_OFFSET+A)<<3)+3)

/* Regular special registers, 0-9 */
#define	LZ8E_SPEC_REG_OFFSET		53
#define	LZ8E_SPEC_REG(A)		(((LZ8E_SPEC_REG_OFFSET+A)<<3))
#define	LZ8E_SPEC_REG_MSH(A)		(((LZ8E_SPEC_REG_OFFSET+A)<<3)+0)
#define	LZ8E_SPEC_REG_LSH(A)		(((LZ8E_SPEC_REG_OFFSET+A)<<3)+2)
#define	LZ8E_SPEC_REG_MSB(A)		(((LZ8E_SPEC_REG_OFFSET+A)<<3)+0)
#define	LZ8E_SPEC_REG_msb(A)		(((LZ8E_SPEC_REG_OFFSET+A)<<3)+1)
#define	LZ8E_SPEC_REG_lsb(A)		(((LZ8E_SPEC_REG_OFFSET+A)<<3)+2)
#define	LZ8E_SPEC_REG_LSB(A)		(((LZ8E_SPEC_REG_OFFSET+A)<<3)+3)

/* LZ8E_ISR-related special registers, 0 */
#define	LZ8E_ISR_REG_OFFSET		63
#define	LZ8E_ISR_REG(A)		(((LZ8E_ISR_REG_OFFSET+A)<<3))
#define	LZ8E_ISR_REG_MSH(A)		(((LZ8E_ISR_REG_OFFSET+A)<<3)+0)
#define	LZ8E_ISR_REG_LSH(A)		(((LZ8E_ISR_REG_OFFSET+A)<<3)+2)
#define	LZ8E_ISR_REG_MSB(A)		(((LZ8E_ISR_REG_OFFSET+A)<<3)+0)
#define	LZ8E_ISR_REG_msb(A)		(((LZ8E_ISR_REG_OFFSET+A)<<3)+1)
#define	LZ8E_ISR_REG_lsb(A)		(((LZ8E_ISR_REG_OFFSET+A)<<3)+2)
#define	LZ8E_ISR_REG_LSB(A)		(((LZ8E_ISR_REG_OFFSET+A)<<3)+3)



#define LZ8E_MMREG_VOID_PTR(A)      (*((void* volatile * const ) (0xFFFFFE00 + (A))))
#define LZ8E_MMREG_WORD(A) (*((unsigned int   volatile * const ) (0xFFFFFE00 + (A))))
#define LZ8E_MMREG_HALF(A) (*((unsigned short volatile * const ) (0xFFFFFE00 + (A))))
#define LZ8E_MMREG_BYTE(A) (*((unsigned char  volatile * const ) (0xFFFFFE00 + (A))))




#define	LZ8E_CRC32			LZ8E_MMREG_WORD(LZ8E_CRC32_REG(0))
#define	LZ8E_CRC32_BYTE		LZ8E_MMREG_BYTE(LZ8E_CRC32_REG_lsb(1))
#define	LZ8E_CRC32_HALF		LZ8E_MMREG_HALF(LZ8E_CRC32_REG_MSH(2))
#define	LZ8E_CRC32_WORD		LZ8E_MMREG_WORD(LZ8E_CRC32_REG(3))

#define	LZ8E_COPY			LZ8E_MMREG_WORD(LZ8E_COPY_REG(0))
#define	LZ8E_COPY_FROM		LZ8E_MMREG_VOID_PTR(LZ8E_COPY_REG(0))
#define	LZ8E_COPY_SIZE		LZ8E_MMREG_WORD(LZ8E_COPY_REG(0))
#define	LZ8E_COPY_TO			LZ8E_MMREG_VOID_PTR(LZ8E_COPY_REG(0))
#define		LZ8E_COPY_TO_CRC32		(0x80000000)
#define		LZ8E_COPY_LENGTH		(0x7FFFFFFF)

#define LZ8E_COPY_STATE		LZ8E_MMREG_BYTE(LZ8E_COPY_REG_LSB(1))
#define LZ8E_CRC32_CONFIG		LZ8E_MMREG_BYTE(LZ8E_COPY_REG_lsb(2))
#define	LZ8E_COPY_BLOCK		LZ8E_MMREG_WORD(LZ8E_COPY_REG(3))

#define	LZ8E_IT0			LZ8E_MMREG_WORD(LZ8E_SPEC_REG(0))
#define	LZ8E_IT1			LZ8E_MMREG_WORD(LZ8E_SPEC_REG(1))
#define	LZ8E_IT2			LZ8E_MMREG_WORD(LZ8E_SPEC_REG(2))
#define	LZ8E_IT3			LZ8E_MMREG_WORD(LZ8E_SPEC_REG(3))
#define LZ8E_IT(n)			LZ8E_MMREG_WORD(LZ8E_SPEC_REG(n))
#define	LZ8E_CPUC			LZ8E_MMREG_WORD(LZ8E_SPEC_REG(4))
#define	LZ8E_RTC			LZ8E_MMREG_WORD(LZ8E_SPEC_REG(5))

#define	LZ8E_LED			LZ8E_MMREG_BYTE(LZ8E_SPEC_REG_MSB(6))
#define	LZ8E_GPIO			LZ8E_MMREG_BYTE(LZ8E_SPEC_REG_MSB(6))
#define		LZ8E_GPIO_LED		0x1
#define		LZ8E_GPIO_RABBIT		0x2
#define		LZ8E_GPIO_SIGNAL_DETECT	0x4

#define	LZ8E_MDI			LZ8E_MMREG_BYTE(LZ8E_SPEC_REG_msb(7))
#define		LZ8E_MDC			(0x04)
#define		LZ8E_MDEN			(0x02)
#define		LZ8E_MDIO			(0x01)

#define LZ8E_PORT_ENABLE		LZ8E_MMREG_BYTE(LZ8E_SPEC_REG_MSB(8))
#define LZ8E_PORT_ENABLE_P0		(0x01)
#define LZ8E_PORT_ENABLE_PCIE	(0x06)
#define LZ8E_PORT_ENABLE_PCIE_PHY	(0x04)

#define	LZ8E_REBOOT_STATUS		LZ8E_MMREG_WORD(LZ8E_SPEC_REG(9))
#define		LZ8E_REBOOT_CAUSE			(0xFC000000)
#define		LZ8E_REBOOT_TIME3_INT		(0x80000000)
#define		LZ8E_REBOOT_MEMORY_INT		(0x40000000)
#define		LZ8E_REBOOT_SEND_BUFFER_PARITY_INT	(0x20000000)
#define		LZ8E_REBOOT_PCIE_BUFFER_PARITY_INT	(0x10000000)
#define		LZ8E_REBOOT_P0_BUFFER_PARITY_INT	(0x08000000)
#define		LZ8E_REBOOT_SRAM_PARITY_INT		(0x04000000)
#define		LZ8E_REBOOT_ADDR			(0x03FFFFFF)

#define	LZ8E_P0_RECV_BUFFER_SIZE	(48*1024)
#define	LZ8E_PCIE_RECV_BUFFER_SIZE	(32*1024)
#define	LZ8E_RECV_BUFFER_WIDTH	16
#define	LZ8E_P0_CHIP_BUFFER		((void*)(0x80000000))
#define	LZ8E_PCIE_CHIP_BUFFER	((void*)(0x80010000))
#define	LZ8E_P0_SRAM_BUFFER		((void*)(SRAM_SIZE-LZ8E_P0_RECV_BUFFER_SIZE))
#define	LZ8E_P0_A_SRAM_BUFFER	((void*)(SRAM_SIZE-(2*LZ8E_P0_RECV_BUFFER_SIZE)))
#define	LZ8E_PCIE_SRAM_BUFFER	((void*)(SRAM_SIZE-(2*LZ8E_P0_RECV_BUFFER_SIZE+LZ8E_PCIE_RECV_BUFFER_SIZE)))

#define	LZ8E_WSCAN			((unsigned int*)((char*)LZ8E_PCIE_SRAM_BUFFER-0x04))
#define	LZ8E_RSCAN			((unsigned int*)((char*)LZ8E_PCIE_SRAM_BUFFER-0x44))
#define	LZ8E_ASCAN			((unsigned int*)((char*)LZ8E_PCIE_SRAM_BUFFER-0xa4))
#define	LZ8E_SCAN_BOTTOM		((unsigned int*)((char*)LZ8E_PCIE_SRAM_BUFFER-0x100))
#define	LZ8E_STRING_SPECS		((char        *)((char*)LZ8E_PCIE_SRAM_BUFFER-0x200))
#define	LZ8E_STRING_SPECS_LEN	256
#define	LZ8E_HIGHMEM_START		((void *)LZ8E_STRING_SPECS)
#define	LZ8E_EXTZONE_START		((void *)(LZ8E_STRING_SPECS - LZ8E_EXTZONE_LEN))
#define	LZ8E_EXTZONE_LEN		32768U

#define	LZ8E_SEND_FIFO_SIZE		(5*1024)
#define	LZ8E_SEND_FIFO_WIDTH		16

#define	LZ8E_WRITE_FIFO_SIZE		(6*1024)

#define	LZ8E_HARDWARE_COMPLETIONS	16

#define	LZ8E_P0_SEND			LZ8E_MMREG_VOID_PTR(LZ8E_P0_SEND_REG(0))
#define	LZ8E_P0_SEND_POINTER		LZ8E_MMREG_VOID_PTR(LZ8E_P0_SEND_REG(0))
#define	LZ8E_P0_SEND_LENGTH		LZ8E_MMREG_WORD(LZ8E_P0_SEND_REG(0))
#define	LZ8E_P0_SEND_COUNT		LZ8E_MMREG_HALF(LZ8E_P0_SEND_REG_LSH(1))

#define	LZ8E_P0_RECV_POINTER		LZ8E_MMREG_HALF(LZ8E_P0_RECV_REG_MSH(0))
#define	LZ8E_P0_RECV_COUNT		LZ8E_MMREG_HALF(LZ8E_P0_RECV_REG_LSH(0))
#define	LZ8E_P0_RECV_SNAPSHOT        LZ8E_MMREG_WORD(LZ8E_P0_RECV_REG(0))
#define		LZ8E_RECV_POINTER		(0xFFFF0000)
#define		LZ8E_RECV_COUNT		(0x0000FFFF)
#define	LZ8E_P0_DROP_COUNT		LZ8E_MMREG_WORD(LZ8E_P0_RECV_REG(1))
#define		LZ8E_PACKET_DROP		(0xFFFF0000)
#define		LZ8E_OVERFLOW_DROP		(0x0000FFFF)
#define	LZ8E_P0_RECV_LIMIT		LZ8E_MMREG_HALF(LZ8E_P0_RECV_REG_LSH(2))

#define	LZ8E_P0_A_RECV_POINTER	LZ8E_MMREG_HALF(LZ8E_P0_RECV_REG_MSH(3))
#define	LZ8E_P0_A_RECV_COUNT		LZ8E_MMREG_HALF(LZ8E_P0_RECV_REG_LSH(3))
#define	LZ8E_P0_A_RECV_SNAPSHOT	LZ8E_MMREG_WORD(LZ8E_P0_RECV_REG(3))
#define	LZ8E_P0_A_DROP_COUNT		LZ8E_MMREG_WORD(LZ8E_P0_RECV_REG(4))
#define	LZ8E_P0_A_RECV_LIMIT		LZ8E_MMREG_HALF(LZ8E_P0_RECV_REG_MSH(5))

#define	LZ8E_PCIE_SEND		LZ8E_MMREG_VOID_PTR(LZ8E_PCIE_SEND_REG(0))
#define	LZ8E_PCIE_SEND_POINTER	LZ8E_MMREG_VOID_PTR(LZ8E_PCIE_SEND_REG(0))
#define	LZ8E_PCIE_SEND_LENGTH	LZ8E_MMREG_WORD(LZ8E_PCIE_SEND_REG(0))
#define	LZ8E_PCIE_SEND_COUNT		LZ8E_MMREG_HALF(LZ8E_PCIE_SEND_REG_MSH(1))

#define	LZ8E_PCIE_RECV_POINTER	LZ8E_MMREG_HALF(LZ8E_PCIE_RECV_REG_MSH(0))
#define	LZ8E_PCIE_RECV_COUNT		LZ8E_MMREG_HALF(LZ8E_PCIE_RECV_REG_LSH(0))
#define	LZ8E_PCIE_RECV_SNAPSHOT	LZ8E_MMREG_WORD(LZ8E_PCIE_RECV_REG(0))
#define	LZ8E_PCIE_DROP_COUNT		LZ8E_MMREG_WORD(LZ8E_PCIE_RECV_REG(1))
	/* how do we define the drop count ????? */
#define	LZ8E_PCIE_RECV_LIMIT		LZ8E_MMREG_HALF(LZ8E_PCIE_RECV_REG_LSH(2))

#define	LZ8E_POINTER_LIMIT_MASK	(0x7FF0)

#define	LZ8E_ISR			LZ8E_MMREG_WORD(LZ8E_ISR_REG(0))

#define		LZ8E_MEMORY_INT		(0x20000000)
#define		LZ8E_SEND_BUFFER_PARITY_INT	(0x10000000)
#define		LZ8E_PCIE_BUFFER_PARITY_INT	(0x08000000)
#define		LZ8E_P0_BUFFER_PARITY_INT	(0x04000000)
#define		LZ8E_SRAM_PARITY_INT		(0x02000000)

#define		LZ8E_WAKE_INT		(0x01000000)
#define		LZ8E_TIME3_INT		(0x00800000)
#define		LZ8E_TIME2_INT		(0x00400000)
#define		LZ8E_TIME1_INT		(0x00200000)
#define		LZ8E_TIME0_INT		(0x00100000)
#define		LZ8E_TIME_INT(n)		(0x00100000<<(n))
#define         LZ8E_COPY_BUSY               (0x00080000)

#define		LZ8E_PCIE_EVENT		(0x00040000)
#define		LZ8E_PCIE_DLL_BUSY		(0x00020000)
#define		LZ8E_PCIE_FC_VC1_CPL_READY	(0x00010000)
#define		LZ8E_PCIE_FC_VC1_NP_READY	(0x00008000)
#define		LZ8E_PCIE_FC_VC1_P_READY	(0x00004000)
#define		LZ8E_PCIE_FC_VC0_CPL_READY	(0x00002000)
#define		LZ8E_PCIE_FC_VC0_NP_READY	(0x00001000)
#define		LZ8E_PCIE_FC_VC0_P_READY	(0x00000800)
#define		LZ8E_PCIE_FC_READY(vc,t)	(0x00000800<<((vc)*3+(t)))
#define		LZ8E_PCIE_PACKET_ACKD	(0x00000400)
#define		LZ8E_PCIE_PACKET_RCVD	(0x00000200)
#define		LZ8E_PCIE_PACKET_SENT	(0x00000100)
#define		LZ8E_PCIE_LINK_DOWN_INT	(0x00000080)

#define		LZ8E_P0_TX_STOPPED		(0x00000040)
#define		LZ8E_P0_RX_STOPPED		(0x00000020)
#define		LZ8E_P0_A_PACKET_RCVD	(0x00000010)
#define		LZ8E_P0_PACKET_HEAD		(0x00000008)
#define		LZ8E_P0_PACKET_RCVD		(0x00000004)
#define		LZ8E_P0_PACKET_SENT		(0x00000002)
#define		LZ8E_P0_LINK_DOWN_INT	(0x00000001)


#define LZ8E_PCIE_FC_VC0_P_LIMIT	 LZ8E_MMREG_WORD(LZ8E_PCIE_REG(0))
#define LZ8E_PCIE_FC_VC0_P_CONSUMED	 LZ8E_MMREG_WORD(LZ8E_PCIE_REG(1))
#define LZ8E_PCIE_FC_VC0_P_REQUEST	 LZ8E_MMREG_HALF(LZ8E_PCIE_REG_LSH(2))
#define LZ8E_PCIE_FC_VC0_NP_LIMIT	 LZ8E_MMREG_WORD(LZ8E_PCIE_REG(3))
#define LZ8E_PCIE_FC_VC0_NP_CONSUMED	 LZ8E_MMREG_WORD(LZ8E_PCIE_REG(4))
#define LZ8E_PCIE_FC_VC0_NP_REQUEST	 LZ8E_MMREG_HALF(LZ8E_PCIE_REG_LSH(5))
#define LZ8E_PCIE_FC_VC0_CPL_LIMIT	 LZ8E_MMREG_WORD(LZ8E_PCIE_REG(6))
#define LZ8E_PCIE_FC_VC0_CPL_CONSUMED LZ8E_MMREG_WORD(LZ8E_PCIE_REG(7))
#define LZ8E_PCIE_FC_VC0_CPL_REQUEST	 LZ8E_MMREG_HALF(LZ8E_PCIE_REG_LSH(8))

#define LZ8E_PCIE_FC_VC1_P_LIMIT	 LZ8E_MMREG_WORD(LZ8E_PCIE_REG(9))
#define LZ8E_PCIE_FC_VC1_P_CONSUMED	 LZ8E_MMREG_WORD(LZ8E_PCIE_REG(10))
#define LZ8E_PCIE_FC_VC1_P_REQUEST	 LZ8E_MMREG_HALF(LZ8E_PCIE_REG_LSH(11))
#define LZ8E_PCIE_FC_VC1_NP_LIMIT	 LZ8E_MMREG_WORD(LZ8E_PCIE_REG(12))
#define LZ8E_PCIE_FC_VC1_NP_CONSUMED	 LZ8E_MMREG_WORD(LZ8E_PCIE_REG(13))
#define LZ8E_PCIE_FC_VC1_NP_REQUEST	 LZ8E_MMREG_HALF(LZ8E_PCIE_REG_LSH(14))
#define LZ8E_PCIE_FC_VC1_CPL_LIMIT	 LZ8E_MMREG_WORD(LZ8E_PCIE_REG(15))
#define LZ8E_PCIE_FC_VC1_CPL_CONSUMED LZ8E_MMREG_WORD(LZ8E_PCIE_REG(16))
#define LZ8E_PCIE_FC_VC1_CPL_REQUEST	 LZ8E_MMREG_HALF(LZ8E_PCIE_REG_LSH(17))

#define LZ8E_PCIE_FC_LIMIT(v,t)	 LZ8E_MMREG_WORD(LZ8E_PCIE_REG(((v)*9)+((t)*3)+0))
#define LZ8E_PCIE_FC_CONSUMED(v,t)	 LZ8E_MMREG_WORD(LZ8E_PCIE_REG(((v)*9)+((t)*3)+1))
#define LZ8E_PCIE_FC_REQUEST(v,t)	 LZ8E_MMREG_HALF(LZ8E_PCIE_REG_LSH(((v)*9)+((t)*3)+2))

#define LZ8E_PCIE_FC_P_LIMIT(v)	 LZ8E_MMREG_WORD(LZ8E_PCIE_REG(((v)*9)+0))
#define LZ8E_PCIE_FC_P_CONSUMED(v)	 LZ8E_MMREG_WORD(LZ8E_PCIE_REG(((v)*9)+1))
#define LZ8E_PCIE_FC_P_REQUEST(v)	 LZ8E_MMREG_HALF(LZ8E_PCIE_REG_LSH(((v)*9)+2))
#define LZ8E_PCIE_FC_NP_LIMIT(v)	 LZ8E_MMREG_WORD(LZ8E_PCIE_REG(((v)*9)+3))
#define LZ8E_PCIE_FC_NP_CONSUMED(v)	 LZ8E_MMREG_WORD(LZ8E_PCIE_REG(((v)*9)+4))
#define LZ8E_PCIE_FC_NP_REQUEST(v)	 LZ8E_MMREG_HALF(LZ8E_PCIE_REG_LSH(((v)*9)+5))
#define LZ8E_PCIE_FC_CPL_LIMIT(v)	 LZ8E_MMREG_WORD(LZ8E_PCIE_REG(((v)*9)+6))
#define LZ8E_PCIE_FC_CPL_CONSUMED(v)	 LZ8E_MMREG_WORD(LZ8E_PCIE_REG(((v)*9)+7))
#define LZ8E_PCIE_FC_CPL_REQUEST(v)	 LZ8E_MMREG_HALF(LZ8E_PCIE_REG_LSH(((v)*9)+8))

#define		LZ8E_FC_DLLP_TYPE		(0xC0000000)
#define			LZ8E_INIT_FC1	(0x40000000)
#define			LZ8E_UPDATE_FC	(0x80000000)
#define			LZ8E_INIT_FC2	(0xC0000000)
#define		LZ8E_FC_HDR_INFINITE		(0x01000000)
#define		LZ8E_FC_HDR			(0x00FF0000)
#define		LZ8E_FC_DATA_INFINITE	(0x00004000)
#define		LZ8E_FC_DATA			(0x00003FFF)


#define	LZ8E_PISR			LZ8E_MMREG_WORD(LZ8E_PCIE_REG(18))
#define	LZ8E_PISR_MASK		LZ8E_MMREG_WORD(LZ8E_PCIE_REG(19))
#define		LZ8E_PCIE_WRITE_FIFO_PARITY_ERROR	(0x00200000)
#define		LZ8E_PCIE_WRITE_FIFO_OVERFLOW_ERROR	(0x00100000)
#define		LZ8E_PCIE_OVERFLOW_ERROR		(0x00080000)
#define		LZ8E_PCIE_POISONED_TLP		(0x00040000)
#define		LZ8E_PCIE_INACTIVE_TAG_ERROR		(0x00020000)
#define		LZ8E_PCIE_LOCKED_COMPLETION_ERROR	(0x00010000)
#define		LZ8E_PCIE_BAD_REQUESTER_ID_ERROR	(0x00008000)
#define		LZ8E_PCIE_MALFORMED_ERROR		(0x00004000)
#define		LZ8E_PCIE_ECRC_ERROR			(0x00002000)
#define		LZ8E_PCIE_BAD_TLP_ERROR		(0x00001000)
#define		LZ8E_PCIE_DLL_PROTOCOL_ERROR		(0x00000800)
#define		LZ8E_PCIE_BAD_DLLP_ERROR		(0x00000400)
#define		LZ8E_PCIE_RECEIVER_ERROR		(0x00000200)
#define		LZ8E_PCIE_VC1_MEMORY_WRITE_RCVD	(0x00000100)
#define		LZ8E_PCIE_VC0_MEMORY_WRITE_RCVD	(0x00000080)
#define		LZ8E_PCIE_GOOD_COMPLETION_RCVD	(0x00000040)
#define		LZ8E_PCIE_DUPLICATE_TLP_WARNING	(0x00000020)
#define		LZ8E_PCIE_RECEIVER_DROP_WARNING	(0x00000010)
#define		LZ8E_PCIE_OTHER_DLLP_RCVD		(0x00000008)
#define		LZ8E_PCIE_NAK_DLLP_RCVD		(0x00000004)
#define		LZ8E_PCIE_ACK_DLLP_RCVD		(0x00000002)
#define		LZ8E_PCIE_FC_DLLP_RCVD		(0x00000001)

#define	LZ8E_PCIE_SEND_DLLP		LZ8E_MMREG_WORD(LZ8E_PCIE_REG(20))

#define	LZ8E_PCIE_FC_UPDATE		LZ8E_MMREG_WORD(LZ8E_PCIE_REG(21))
#define		LZ8E_FC_SET			(0x80000000)
#define		LZ8E_FC_VC			(0x40000000)
#define		LZ8E_FC_NP			(0x20000000)

#define	LZ8E_PCIE_DLL_CONFIG		LZ8E_MMREG_WORD(LZ8E_PCIE_REG(22))
#define		LZ8E_DLL_REG			0xF0000000
#define			LZ8E_DLL_REG_UNBLOCK		0x10000000
#define			LZ8E_DLL_REG_CONTROL		0x20000000
#define			LZ8E_DLL_REG_SEND_FC		0x30000000
#define			LZ8E_DLL_REG_DLLP_ENABLE	0x40000000
#define			LZ8E_DLL_REG_CLEAR_CACHE	0x50000000
#define			LZ8E_DLL_REG_SEND_SEQ	0x60000000
#define			LZ8E_DLL_REG_RECV_SEQ	0x70000000
#define			LZ8E_DLL_REG_ACK_LATENCY	0x80000000
#define			LZ8E_DLL_REG_FC_LATENCY	0x90000000
#define			LZ8E_DLL_REG_WRITE_SPLIT	0xA0000000

#define	LZ8E_DLL_GENERATE_VC0_P_CREDIT	0x20000
#define	LZ8E_DLL_GENERATE_VC0_NP_CREDIT	0x10000
#define	LZ8E_DLL_GENERATE_VC1_P_CREDIT	0x08000
#define	LZ8E_DLL_GENERATE_VC1_NP_CREDIT	0x04000
#define	LZ8E_DLL_FILTER_PASS_ALL_GOOD_DLLP	0x00200
#define	LZ8E_DLL_FILTER_PASS_ALL_GOOD_PM	0x00100
#define	LZ8E_DLL_FILTER_PASS_ALL_GOOD_ACK	0x00080
#define	LZ8E_DLL_FILTER_PASS_ALL_GOOD_FC	0x00040
#define	LZ8E_DLL_FILTER_PASS_ALL_GOOD_VENDOR	0x00020
#define	LZ8E_DLL_FILTER_PASS_SHORT_TLP	0x00010
#define	LZ8E_DLL_FILTER_PASS_REDUNDANT_TLP	0x00008
#define	LZ8E_DLL_FILTER_PASS_OUT_OF_SEQ_TLP	0x00004
#define	LZ8E_DLL_FILTER_DONT_PASS_ALL_TLP	0x00002
#define	LZ8E_DLL_FC_BLOCK_VC0_P_TLP		0x00001

#define LZ8E_PCIE_DLLP_ENABLE(code)	LZ8E_PCIE_DLL_CONFIG = LZ8E_DLL_REG_DLLP_ENABLE | (code)
#define		LZ8E_DLL_CODE_FC_VC2_P			(0x00000000)
#define		LZ8E_DLL_CODE_FC_VC2_NP			(0x00000001)
#define		LZ8E_DLL_CODE_FC_VC2_CPL			(0x00000002)
#define		LZ8E_DLL_CODE_FC_VC3_P			(0x00000003)
#define		LZ8E_DLL_CODE_FC_VC3_NP			(0x00000004)
#define		LZ8E_DLL_CODE_FC_VC3_CPL			(0x00000005)
#define		LZ8E_DLL_CODE_FC_VC4_P			(0x00000006)
#define		LZ8E_DLL_CODE_FC_VC4_NP			(0x00000007)
#define		LZ8E_DLL_CODE_FC_VC4_CPL			(0x00000008)
#define		LZ8E_DLL_CODE_FC_VC5_P			(0x00000009)
#define		LZ8E_DLL_CODE_FC_VC5_NP			(0x0000000A)
#define		LZ8E_DLL_CODE_FC_VC5_CPL			(0x0000000B)
#define		LZ8E_DLL_CODE_FC_VC6_P			(0x0000000C)
#define		LZ8E_DLL_CODE_FC_VC6_NP			(0x0000000D)
#define		LZ8E_DLL_CODE_FC_VC6_CPL			(0x0000000E)
#define		LZ8E_DLL_CODE_FC_VC7_P			(0x0000000F)
#define		LZ8E_DLL_CODE_FC_VC7_NP			(0x00000010)
#define		LZ8E_DLL_CODE_FC_VC7_CPL			(0x00000011)
#define		LZ8E_DLL_CODE_FC_PM_ENTER_L1			(0x00000012)
#define		LZ8E_DLL_CODE_FC_PM_ENTER_L23		(0x00000013)
#define		LZ8E_DLL_CODE_FC_PM_ACTIVE_STATE_REQUEST_L1	(0x00000014)
#define		LZ8E_DLL_CODE_FC_PM_REQUEST_ACK		(0x00000015)
#define		LZ8E_DLL_CODE_FC_VENDOR_SPECIFIC		(0x00000016)
#define		LZ8E_DLL_CODE_FC_RESERVED			(0x00000017)
#define		LZ8E_DLL_CODE_FC(vc,type)			((vc-2)*3+(type))
#define		LZ8E_DLL_CODES				(0x00000018)

#define	LZ8E_PCIE_SEQUENCE		LZ8E_MMREG_HALF(LZ8E_PCIE_REG_MSH(23))
#define	LZ8E_PCIE_ACK_NAK		LZ8E_MMREG_HALF(LZ8E_PCIE_REG_LSH(23))
#define		LZ8E_TLP_NAK			(0x00001000)
#define		LZ8E_TLP_SEQUENCE		(0x00000FFF)

#define LZ8E_PCIE_SEND_CHECKSUM	LZ8E_MMREG_HALF(LZ8E_PCIE_REG_MSH(24))

#define	LZ8E_DISPATCH_STATE		LZ8E_MMREG_WORD(LZ8E_DISPATCH_REG(0))
#define	LZ8E_DISPATCH_INDEX		LZ8E_MMREG_HALF(LZ8E_DISPATCH_REG_MSH(0))
#define LZ8E_DISPATCH_ISR_ON		LZ8E_MMREG_WORD(LZ8E_DISPATCH_REG(1))
#define LZ8E_DISPATCH_ISR_OFF	LZ8E_MMREG_WORD(LZ8E_DISPATCH_REG(2))
#define LZ8E_DISPATCH_STATE_ON	LZ8E_MMREG_WORD(LZ8E_DISPATCH_REG(3))
#define LZ8E_DISPATCH_STATE_OFF	LZ8E_MMREG_WORD(LZ8E_DISPATCH_REG(4))
#define LZ8E_DISPATCH_CONFIG		LZ8E_MMREG_WORD(LZ8E_DISPATCH_REG(5))

#define		LZ8E_DISPATCH_AND		(0x00000100)
#define		LZ8E_DISPATCH_OR		(0x00000080)
#define		LZ8E_DISPATCH_INVERT		(0x00000040)
#define		LZ8E_DISPATCH_SELECT		(0x0000001F)

#define LZ8E_JTAG_MASTER     	LZ8E_MMREG_WORD(LZ8E_JTAG_REG(0))


/*  PCIE-Port SPD */
#define		LZ8E_DESC_DLLP		(0x8000)
#define		LZ8E_DESC_TLP	       	(0x0000)
#define		LZ8E_DESC_USE_VC0_P_CREDIT	(0x4000)
#define		LZ8E_DESC_SPLIT_MWR		(0x1000)
#define		LZ8E_DESC_OFFSET		(0x00FF)


/*  Z-Port LZ8E_RPD, flags */
#define		LZ8E_DESC_BAD		(0xC000)
#define		LZ8E_DESC_BAD_CRC		(0x8000)
#define		LZ8E_DESC_BAD_PHY		(0x4000)

/*  PCIE-Port LZ8E_RPD */
#define		LZ8E_DESC_PCIE_RCODE		(0xF800)
#define		LZ8E_DESC_PCIE_LENGTH	(0x07FF)


/*  SPD, msw */
#define		LZ8E_DESC_PAYLOAD		(0x80000000)
#define		LZ8E_DESC_POINTER		(0x7FFFFFFF)
/*  SPD, lsw */
#define         LZ8E_DESC_INVALIDATE		(0x20000000)
#define         LZ8E_DESC_LAST		(0x10000000)
#define         LZ8E_DESC_CPL		(0x08000000)

/*  Completion SPD, msw */
#define		LZ8E_CPL_CONFIG_ON_CHIP	(0x80000000)
#define		LZ8E_CPL_CONFIG_CANCEL	(0x40000000)
#define		LZ8E_CPL_CONFIG_ADDRESS	(0x0FFFFFFF)
/*  Completion SPD, lsw */
#define         LZ8E_CPL_CONFIG_TAG		(0xF0000000)
#define		LZ8E_CPL_CONFIG_SPD		(0x08000000)
#define         LZ8E_CPL_CONFIG_OFFSET	(0x00FF0000)
#define         LZ8E_CPL_CONFIG_PCI_ADDRESS	(0x0000E000)
#define         LZ8E_CPL_CONFIG_LENGTH	(0x00001FFF)


/*  Completion Notification, msw */
#define LZ8E_CPL_RCODE			(0xF8000000)
#define LZ8E_CPL_OVERFLOW			(0x02000000)
#define LZ8E_CPL_UNDERFLOW			(0x01000000)
#define LZ8E_CPL_POISONED			(0x00800000)
#define LZ8E_CPL_STATUS			(0x00700000)
#define LZ8E_CPL_TAG				(0x000F0000)
#define LZ8E_CPL_CHECKSUM			(0x0000FFFF)


/*  RCODEs */
#define	LZ8E_RCODE_DLLP_PHY_ERROR		0
#define	LZ8E_RCODE_DLLP_3_WORD		1
#define	LZ8E_RCODE_DLLP_OTHER		2
#define	LZ8E_RCODE_TLP_PHY_ERROR		3
#define	LZ8E_RCODE_TLP_EDB			4
#define	LZ8E_RCODE_TLP_3_WORD		5
#define	LZ8E_RCODE_TLP_ERROR			6
#define	LZ8E_RCODE_TLP_DUPLICATE	        7
#define	LZ8E_RCODE_TLP_REG_WRITE_32_0	8
#define	LZ8E_RCODE_TLP_REG_WRITE_64_0	9
#define	LZ8E_RCODE_TLP_REG_WRITE_32_1	10
#define	LZ8E_RCODE_TLP_REG_WRITE_64_1	11
#define LZ8E_RCODE_TLP_REG_WRITE(_64,TD)	(8+_64+(TD*2))
#define	LZ8E_RCODE_TLP_EXT_WRITE_32_0	12
#define	LZ8E_RCODE_TLP_EXT_WRITE_64_0	13
#define	LZ8E_RCODE_TLP_EXT_WRITE_32_1	14
#define	LZ8E_RCODE_TLP_EXT_WRITE_64_1	15
#define LZ8E_RCODE_TLP_EXT_WRITE(_64,TD)	(12+_64+(TD*2))
#define	LZ8E_RCODE_TLP_COMPLETION		16
#define	LZ8E_RCODE_TLP_OTHER			17
#define	LZ8E_RCODE_CPL_END			18
#define	LZ8E_RCODE_CPL_ERROR			19

#define	LZ8E_NUMBER_OF_RCODES		20


#define	LZ8E_MYRINET_MODE		0
#define	LZ8E_MYRINET_SAFE_MODE	1
#define	LZ8E_ETHERNET_MODE		2


#define	LZ8E_REBOOT_ON_SRAM_PARITY_INT		0x01
#define	LZ8E_REBOOT_ON_P0_BUFFER_PARITY_INT		0x02
#define	LZ8E_REBOOT_ON_PCIE_BUFFER_PARITY_INT	0x04
#define	LZ8E_REBOOT_ON_SEND_BUFFER_PARITY_INT	0x08
#define	LZ8E_REBOOT_ON_MEMORY_INT			0x10
#define	LZ8E_REBOOT_ON_TIME3_INT			0x20

#define LZ8E_DEFAULT_CLOCK 0x0d42U

#define	LZ8E_WAIT_1_CYCLE	\
	{		\
	    asm("nop"); \
	}

#define	LZ8E_WAIT_2_CYCLES	\
	{		\
	    asm("nop"); \
	    asm("nop"); \
	}

#define	LZ8E_WAIT_5_CYCLES	\
	{		\
	    asm("nop"); \
	    asm("nop"); \
	    asm("nop"); \
	    asm("nop"); \
	    asm("nop"); \
	}


#define LZ8E_RPD trick gen_prefixed_headers into renaming LZ8E_RPD
#undef LZ8E_RPD
typedef	struct	LZ8E_RPD
{
    unsigned int	skip;
    unsigned short	flags;
    unsigned short	length;
} LZ8E_RPD;


#endif /* LZ8E_LANAI_Z8E_DEF_H */
