#ifndef LF_OS_SPECIFIC_H
#define LF_OS_SPECIFIC_H

#ifndef _WIN32
#include <unistd.h>
#include <netinet/in.h>
#include <sys/time.h>

#define lf_sleep(x_) sleep((x_))
#define lf_srandom(x_) srandom((x_))
#define lf_random random
#define lf_vsnprintf vsnprintf
#define lf_snprintf snprintf
#define lf_gettimeofday gettimeofday

#else

#define lf_sleep(x_) Sleep((x_) * 1000)
#define lf_srandom(x_) srand((x_))
#define lf_random rand
#define lf_vsnprintf _vsnprintf
#define lf_snprintf _snprintf
int lf_gettimeofday (struct timeval* tv, void* tz);

int	 getopt(int, char * const [], const char *);

extern char *optarg;			/* getopt(3) external variables */

#endif

#endif
